unit uextras;

{$mode objfpc}{$H+}

interface

uses
  LCLIntf,  SysUtils, Classes, Graphics, Controls, Forms,contnrs,
  Dialogs, ExtCtrls,StdCtrls,upaint2ObjBase,uPaint2Object,FPCanvas,GraphicPropEdit;

type

  TPaint2List = class(TPaint2Object)
  public
    items:TObjectList;
    constructor Create;
    procedure Save(Stringlist:TStringList;stream:TStream);
    procedure load(Stringlist:TStringList;stream:TStream);
  end;
  
  { tImageListB }
  tImageListB = class(TPaint2List)
  public
    constructor Create;
    procedure Save(Stringlist:TStringList;stream:TStream);
    procedure load(Stringlist:TStringList;stream:TStream);
  private
    fpx,fpy,fsx,fsy:Integer;
    fImage:TImage;
    function GetPicture:TPicture;
    procedure SetPicture(Value: TPicture);
    procedure SetIndex(index,value:Integer);
    function GetIndex(index:Integer):integer;
  published
    property PX:Integer index 1 read getIndex write SetIndex;
    property PY:Integer index 2 read getIndex write SetIndex;
    property SX:Integer index 3 read getIndex write SetIndex;
    property SY:Integer index 4 read getIndex write SetIndex;
    property Image: TPicture read GetPicture write SetPicture;
  end;

implementation

constructor TPaint2List.Create;
begin
  inherited Create;
  items:=TObjectList.Create;
end;

procedure TPaint2List.Save(Stringlist:TStringList;stream:TStream);
begin
  inherited;
  if Stringlist <> NIL then begin
  end;

  if stream <> NIL then begin
  end;

end; // save

procedure TPaint2List.load(Stringlist:TStringList;stream:TStream);
begin
  inherited;
  if Stringlist <> NIL then begin
  end;

  if stream <> NIL then begin
  end;
end; // load

constructor tImageListB.Create;
begin
  inherited Create;
  Name:='ImagelistB';
  fImage:=TImage.Create(Screen.ActiveForm);
end;

procedure tImagelistb.SetIndex(index,value:Integer);
begin
  if index = 1 then fpx:=Value;
  if index = 2 then fpy:=Value;
  if index = 3 then fsx:=Value;
  if index = 4 then fsy:=Value;
end;

function tImagelistb.GetIndex(index:Integer):integer;
begin
  if index = 1 then result:=fpx;
  if index = 2 then result:=fpy;
  if index = 3 then result:=fsx;
  if index = 4 then result:=fsy;
end;

function tImagelistb.GetPicture: TPicture;
begin
  result:=fImage.Picture;
end;

procedure tImagelistb.SetPicture(Value: TPicture);
begin
   if (Value <> fImage.Picture) then
   fImage.Picture:= Value;
end;

procedure tImagelistb.Save(Stringlist:TStringList;stream:TStream);
begin
  inherited;
  if Stringlist <> NIL then begin
  end;
  
  if stream <> NIL then begin
  end;
end; // save

procedure tImagelistb.load(Stringlist:TStringList;stream:TStream);
begin
  inherited;
  if Stringlist <> NIL then begin
  end;

  if stream <> NIL then begin
  end;

end; // load


end.

