{
 für ein objekt brauche ich:
 isShfit, Adding, TObjektlist
}

unit upaint2main;

{$mode objfpc}{$H+}

interface

uses
  LCLIntf,  SysUtils, Classes, Graphics, Controls, uliste,Forms,ComCtrls,types,
  Dialogs, ExtCtrls, StdCtrls,uPaint2Obj,RTTIGrids,inifiles,uPaint2Object,upaint2ObjBase,LMessages,contnrs;
  
type

  tonAddObj = procedure(obj:TPaint2BasesObj;isload:Boolean) of Object;
  TonChangeObj = procedure(Newobj:TPaint2BasesObj) of object;
  tOnSizeChange = procedure(NW,NH:integer) of object;
  tDeleteObj = procedure(index:Integer) of object;


  TMouseDown1 =  procedure(sender:TObject;Button: TMouseButton;Shift: TShiftState; X, Y: Integer) of object;
  TMouseMove1 =  procedure(Sender: TObject;Shift: TShiftState; X,Y: Integer) of object;
  TMouseUp1 = procedure(Sender: TObject;Button: TMouseButton; Shift:TShiftState; X,Y:Integer) of object;

  { TPaint2Main }


  TPaint2Main = class(TCustomControl)
  private
    buffer:TBitMap;
    fPen:TPen;
    fBrush:TBrush;
    fstartw,fstarth:Integer;
    function Getbrush: TBrush;
    function GetPen: TPen;
    function GetSize: TPoint2;
    procedure SetBrush(const AValue: TBrush);
    procedure SetPen(const AValue: TPen);
    procedure SetSize(const AValue: TPoint2);
  public
    isload:Boolean;
    fPanel:TPanel;
    isShift:Boolean;
    liste:TmyList;
    onAddObj:tonAddObj;
    onChangeobj:TonChangeObj;
    onChangeSize:tOnSizeChange;
    onDeleteObj:tDeleteObj;
    isup:Boolean;
    ti,tc:Integer;
    ox,oy,ow,oh:Integer;
    t:Boolean;
    mx,my,sx,sy:Integer;
    itemselcount:Integer;
    oldpos:TPoint;
    onMouseMove1:TMouseMove1;
    onMouseDown1:TMouseDown1;
    onMouseUp1:TMouseUp1;
    asf:TRect;
  x1,y1,w1,h1:Integer;
    procedure MouseDown(Button:TMouseButton;Shift: TShiftState; X,Y: Integer);override;
    procedure MouseMove(Shift: TShiftState; X,Y: Integer);override;
    procedure MouseUp(Button: TMouseButton; Shift:TShiftState; X,Y:Integer);override;

    procedure PaintAllobj;

    constructor Create(AOwner:TComponent;flistbox:TListBox;oi:TTIPropertyGrid;Panel:TPanel;w,h:Integer);
    destructor Destroy;override;
    procedure AddObj(toolindex,x,y,w,h:integer);

    procedure DelSelObj;
    procedure LoadVorlage(FileName:TFileName;obj:TPaint2BasesObj);
    procedure SaveVorlage(FileName:TFileName;obj:TPaint2BasesObj);
    procedure LoadFromFile(FileName:TFileName);
    procedure Paint; override;
    procedure SetSizeAllBuffers(w,h:Integer);
    procedure ChanageSelecolor(o:TPaint2BasesObj);
    procedure MoveObj(x,y:Integer);
    procedure SelectAllTyp(ptyp:Integer);
    procedure AddDocument(isAutoTabeName:Boolean;PageControl:Tpagecontrol;cp:String);
    procedure ChangeDocument(Panel:TPanel;oldindex,Index:Integer);
    procedure Scroll(Sender: TObject);
  protected
    procedure WMRButtonDBLCLK(Var Message: TLMRButtonDblClk); message LM_RBUTTONDBLCLK;
  published
    property Size:TPoint2 read GetSize write SetSize;
    property Brush:TBrush read Getbrush write SetBrush;
    property Pen:TPen read GetPen write SetPen;
  end;
  
var
  paint2:TPaint2Main;
  b:Boolean;
  oldobj:TPaint2BasesObj;

implementation

uses uPaint2Raster;
{ TPaint2Main }

procedure TPaint2main.Scroll(Sender: TObject);
begin
  asf:=(sender as TScrollBox).Canvas.ClipRect;
  x1:=(sender as TScrollBox).left;
  y1:=(sender as TScrollBox).top;
end;

procedure TPaint2Main.WMRButtonDBLCLK(Var Message: TLMRButtonDblClk);
begin
  if liste.selobject <> NIL then
  SelectAllTyp(liste.selobject.typ); Invalidate;
end;

procedure TPaint2Main.SelectAllTyp(ptyp:Integer);
var
  i:Integer;
begin
  if ptyp > -1 then begin
    for i:=0 to liste.AktivDocument.objlist.count-1 do begin
      with TPaint2BasesObj(liste.AktivDocument.objlist[i]) do begin
        if Typ = pTyp then
          Sel:=true
       else
          Sel:=false
      end;
    end;
  end;
  isShift:=True;
end;

procedure tPaint2Main.ChanageSelecolor(o:TPaint2BasesObj);
begin
end;

procedure TPaint2Main.MouseDown(Button:TMouseButton;Shift: TShiftState; X,Y: Integer);
begin
  onMouseDown1(self,button,shift,x,y);
  inherited MouseDown(Button,Shift,X,Y);
  if ssRight in Shift = false then begin
    oldpos.x:=x; oldpos.Y:=y;
  end;
  ox:=x; oy:=y; Invalidate;
end;

procedure TPaint2Main.MouseMove(Shift: TShiftState; X,Y: Integer);
var
  ti1:Prect;
begin
  ow:=x; oh:=y; onMouseMove1(self,Shift,x,y);
  if shift <> [] then begin
    inherited MouseMove(Shift,X,Y);
    ti1:=@asf;
    InvalidateRect(Handle,ti1,true);
//    Invalidate;
  end;
  oldpos.x:=x; oldpos.y:=y;
end;

procedure TPaint2Main.MouseUp(Button: TMouseButton; Shift:TShiftState; X,Y:Integer);
begin
  onMouseUp1(self,Button,shift,x,y);
  inherited Mouseup(Button,Shift,X,Y);
  liste.isObjMove:=False;
  if liste.selobject <> NIl then begin
    liste.selobject.pointDrawMove:=-1;
    liste.selobject.pointDrawDown:=-1;
  end;
  Invalidate;
end;

function TPaint2Main.GetSize: TPoint2;
var
  aValue:TPoint2;
begin
  aValue:=TPoint2.create;
  aValue.x:=buffer.Width;
  aValue.y:=buffer.Height;
  result:=aValue;
end; // GetSize

procedure TPaint2Main.SetSize(const AValue: TPoint2);
begin
  SetSizeAllBuffers(AValue.x,AValue.y);
  if Assigned(onChangeSize) then onChangeSize(AValue.x,AValue.y)
end; // SetSize

function TPaint2Main.Getbrush: TBrush;
begin
  result:=fbrush;
end;

procedure TPaint2Main.SetBrush(const AValue: TBrush);
begin
  fbrush.Assign(AValue);

end;

function TPaint2Main.GetPen: TPen;
begin
  result:=fPen;
end;

procedure TPaint2Main.SetPen(const AValue: TPen);
begin
  fpen.Assign(avalue);
end;

constructor TPaint2Main.Create(AOwner:TComponent;flistbox:TListBox;oi:TTIPropertyGrid;Panel: TPanel; w, h: Integer);
begin
  inherited Create(AOwner);
  b:=False;
  itemselcount:=0;
  Buffer:=TBitmap.create;
//  Buffer.Width:=w;   Buffer.Height:=h;
  liste:=TmyList.Create(oi,buffer);
  liste.usrListBox:=flistbox;
  fPen:=TPen.Create;
  fPen.color:=clYellow;
  fBrush:=TBrush.Create;
  fBrush.Color:=clLime;
  fpanel:=panel;
  ti:=0; tc:=30;
  paint2:=Self;
  fstartw:=w; fstarth:=h;
  size:=pointTOTPoint2(fstartw,fstarth);

  if liste.Documentindex > -1 then
    liste.selobject:=liste.AktivDocument.bg;
end; // Create

procedure TPaint2Main.AddObj(toolindex,x,y,w,h: integer);
var
  pobj:TPaint2Object;
begin
  pobj:=liste.AddObj(toolindex);
  if pobj <> NIL then begin
    if toolindex < 80 then begin
      with TPaint2BasesObj(pobj) do begin
        pointDrawDown:=-1;   pointDrawMove:=-1;

        Position:=pointTOTPoint2(x,y);
        Size:=pointTOTPoint2(w,h);
        if toolindex = alt_Line then
          PointsModus:=1
        else
          PointsModus:=0;

        typ:=toolindex;
        Name:=Name + IntTostr(liste.GetName(typ)+1);
        Brush.Color:=clLime;
        sel:=true;
        visible:=true;
        pointDrawDown:=2;
        isfocus:=true;
        Raster.rx:=16;         Raster.ry:=16;
        Raster.onChangeValue:=@Paint;
       if Assigned(onAddObj) then onAddObj(liste.selobject,isload);
       if Assigned(onChangeobj) then onChangeobj(liste.selobject);
      end;
    end
    else begin
    liste.usrListBox.Items[liste.usrListBox.items.Count-1]:=liste.usrListBox.items[liste.usrListBox.items.Count-1] +IntTostr(liste.GetName(toolindex));
    end;

  end
  else
    WriteLN('Das Objekt: ' + IntTostr( toolindex) + #13#10'wird zur zeit noch nicht untersttzt !');

end; // AddObj

procedure Tpaint2Main.DelSelObj;
begin
  liste.DeleteObject(-2);
  Paint;

  if Assigned(onChangeobj) then onChangeobj(liste.selobject);

end;

procedure Tpaint2Main.LoadVorlage(FileName:TFileName;obj:TPaint2BasesObj);
var
  Emty:TIniFile;
begin
  Emty:=TIniFile.Create(FileName);
  if obj <> nil then begin
    with Emty do begin
      obj.Brush.Color:=StringToColor(ReadString('obj','Brush.Color',''));
      obj.Brush.Style:=TBrushStyle(ReadInteger('obj','Brush.Style',0));

      obj.Pen.Color:=StringToColor(ReadString('obj','Pen.Color',''));
      obj.Pen.Style:=TPenStyle(ReadInteger('obj','Pen.Style',0));

      obj.Pen.Width:=ReadInteger('obj','Pen.Width',0);
    end;
  end;
  Emty.free;
end;

procedure Tpaint2Main.SaveVorlage(FileName:TFileName;obj:TPaint2BasesObj);
var
  Emty:TIniFile;
begin
  Emty:=TIniFile.Create(FileName);
  if obj <> nil then begin
    with Emty do begin
      WriteString('obj','Brush.Color',ColorToString(obj.Brush.Color));
      WriteInteger('obj','Brush.Style',integer(obj.Brush.Style));

      WriteString('obj','Pen.Color',ColorToString(obj.Pen.Color));
      WriteInteger('obj','Pen.Style',integer(obj.Pen.Style));
      WriteInteger('obj','Pen.Width',integer(obj.Pen.Width));

    end;
  end;
  Emty.free;
end;

procedure TPaint2Main.LoadFromFile(FileName:TFileName);
begin
   liste.LoadFromFile(Filename);
   paint;
end;

procedure TPaint2Main.Paint;
var
  r1,r2,r3:TRect;
  px1,py1,sx1,sy1,i,sx2,sw,sh:Integer;
begin
  inherited Paint;
  if liste.AktivDocument.bg <> NIL then begin
    with liste.AktivDocument do begin
      sf.left:=asf.left-80;
      sf.top:=asf.top-80;
      sf.Right:=sf.left+(asf.Right+80);
      sf.Bottom:=sf.top+(asf.Bottom+80);
      bg.Pen.color:=bg.Brush.color;
      bg.Draw(buffer,false,sf.Left,sf.top,sf.Right,sf.Bottom);
    end;
//    liste.AktivDocument.bg.raster.Draw(liste.AktivDocument.bg.position.x,liste.AktivDocument.bg.position.y,liste.AktivDocument.bg.size.x,liste.AktivDocument.bg.size.y,buffer,liste.AktivDocument.bg.oldpen,liste.AktivDocument.bg.oldbrush);
  end;

  sw:=-1; sh:=-1;
  if liste.Documentindex > -1 then begin
    with Buffer.Canvas do begin
      for i:=0 to liste.AktivDocument.objlist.count-1 do begin
        with TPaint2BasesObj(liste.AktivDocument.objlist[i]) do begin
           r1.left:=Position.x;
           r1.top:=Position.y;
           r1.Bottom:=Size.y;
           r1.Right:=Size.x;

           with liste.AktivDocument do
      Screen.Forms[0].caption:=IntTostr(asf.left) + '\' + intTostr(asf.top) + '\' + IntTostr(asf.Right) + '\'+ intTostr(asf.Bottom) + '------------' + IntTostr(r1.left) + '\' + IntTostr(r1.top) + '\' + intTostr(r1.Right) + '\' + IntTostr(r1.Bottom);

           if (visible = true) and (IntersectRect(r2,liste.AktivDocument.sf,r1) = true) then begin
             buffer.canvas.Brush.style:=bsSolid;

             if (isfocus) or (liste.itemindex = i) then
                buffer.canvas.Brush.color:=clBlack
             else
              if sel then buffer.canvas.Brush.color:=clred;
             buffer.canvas.Pen.Style:=psSolid; buffer.canvas.Pen.color:=clYellow;

             // Damit es einen sichtbaren makierungs Rahmen gibt
             if ((pointDrawDown > -1 ) or (sel) or (isfocus)) and (typ <> alt_Line) then begin
               px1:=Position.x-5;
               py1:=position.y-5;
               sx1:=Size.x+5;
               sy1:=Size.y+5;
               FillRect(px1,py1,sx1,sy1);
             end;

             // damit der makierungs rahmen gezeichnet wird
             // muss geprüft werden ob ein pointDrawMove gesetzt ist
             // oder das objekt den focus hat wenn ja dann zeichne
             Draw(buffer,(pointDrawDown > -1) or (pointDrawMove > -1) or (isfocus = true),-1,-1,-1,-1);

             Raster.Draw(Position.x,position.y,Size.x,Size.y,buffer,oldpen,oldbrush);
           end; // if Visible
        end; // with TPaint2BasesObj(liste.liste[i])
      end; // for
    end; // with buffer2.canvas
  end; // if Documentenindex
  Canvas.Draw(0,0,Buffer);
end; // procedure Paint

destructor TPaint2Main.Destroy;
var
  i:integer;
begin
  inherited Destroy;
  buffer.free;
  for i:=0 to High(liste.Documentlist) do
    liste.Documentlist[i].objlist.Clear;

  SetLength(liste.Documentlist,0);
  liste.Free;
end;

procedure TPaint2Main.PaintAllobj;
var
  i:Integer;
begin
  for i:=0 to liste.AktivDocument.objlist.count-1 do begin
    if i <> liste.itemindex then
      TPaint2BasesObj(liste.AktivDocument.objlist).Draw(buffer,false,-1,-1,0,0);
  end;
end;

procedure TPaint2main.SetSizeAllBuffers(w,h:Integer);
begin
  if Assigned(Buffer) then begin
    Width:=w; Height:=h;

    buffer.Width:=w; buffer.Height:=h;

    buffer.canvas.FillRect(asf);

    if (liste.AktivDocument <> nil) and (liste.AktivDocument.bg <> NIL) then
      liste.AktivDocument.bg.size:=pointTOTPoint2(w,h);

    Invalidate;

  end;
end;

procedure TPaint2main.MoveObj(x,y:Integer);
begin
  liste.MoveObj(x,y,oldpos)
end;

procedure TPaint2main.AddDocument(isAutoTabeName:Boolean;PageControl:Tpagecontrol;cp:String);
var
  sheet:TTabSheet;
  Panela:TPanel;
  str:String;
  wert:Integer;
  Scrollbox:TScrollBox;
begin
  sheet:=TTabSheet.Create(PageControl); sheet.PageControl:=PageControl;
  if cp = '' then begin // wenn kein documenten namen angeben ist, ist für loardfiles aus ulist wichtig !
    str:='Document ' + IntToStr(PageControl.PageCount);

    if isAutoTabeName = false then
     InputQuery('Documenten Namen eingbene','name',str);
  end
  else
    str:=cp;

  Sheet.caption:=extractFileName(str);
  sheet.TabVisible:=True; sheet.Visible:=true;

  Scrollbox:=TScrollBox.Create(Sheet);
  Scrollbox.Parent:=Sheet;
  Scrollbox.Align:=alClient;
  Scrollbox.AutoScroll:=True;
  Scrollbox.OnResize:=@Scroll;
  scrollbox.OnPaint:=@Scroll;
  Panela:=TPanel.Create(Scrollbox); Panela.Align:=alClient;
  Panela.Parent:=Scrollbox;
  Panela.OnMouseDown:=onMouseDown1;
  Panela.OnMouseUP:=onMouseUp1;
  Panela.OnMouseMove:=onMouseMove1;
  Panela.Width:=fstartw; Panela.Height:=fstarth;
  SetLength(liste.Documentlist,high(liste.Documentlist)+2);
  liste.Documentlist[high(liste.Documentlist)]:=TDocumentList.Create;

  liste.Documentindex:=high(liste.Documentlist);
  Parent:=Panela;
  liste.AktivDocument.objlist:=TObjectList.Create;


  if liste.AktivDocument.bg = NIL then begin
    liste.AktivDocument.bg:=Tbg.Create(buffer,Panela);
    with liste.AktivDocument.bg do begin
      Typ:=Backgrund;
      Brush.color:=clBlue;
      Pen.Style:=psSolid;
      Visible:=true;
      Position:=pointTOTPoint2(0,0);
      size:=pointTOTPoint2(fstartw,fstarth);
      PointsModus:=0;
      pointDrawDown:=2;
      Raster:=TPaint2Raster.create;
      Raster.rx:=16; Raster.ry:=16;
      Raster.onChangeValue:=@paint2.Paint;
    end;
  end;

  liste.AktivDocument.FileName:=sheet.Caption;


  if (liste.Documentindex > -1) and (liste.Documentindex <= high(liste.Documentlist) )then begin
    liste.AktivDocument.isShift:=isShift;
    PageControl.ActivePageIndex:=liste.Documentindex;
  end;
end; // AddDocument

procedure TPaint2main.ChangeDocument(Panel:TPanel;oldindex,Index:Integer);
var
  i:Integer;
begin
 Parent:=Panel;
 if (oldindex > -1) and (oldindex <= high(liste.Documentlist) )then begin
   liste.Documentlist[oldindex].isShift:=isShift;
 end;

 if index <= high(liste.Documentlist) then begin
   liste.Documentindex:=index;
   buffer.Width:=liste.AktivDocument.bg.size.x;
   buffer.Height:=liste.AktivDocument.bg.size.y;
   Width:=buffer.Width; Height:=buffer.Height;
   Panel.Width:=Width;Panel.Height:=Height;
   liste.AktivDocument.bg.size:=pointTOTPoint2(buffer.Width,buffer.Height);
   Invalidate;
   isShift:=liste.AktivDocument.isShift;

   for i:=0 to liste.AktivDocument.objlist.Count-1 do begin
     onAddObj(TPaint2BasesObj(liste.AktivDocument.objlist[i]),isload);
   end;
 end;
 
 liste.oldItemindex:=-1;

end;

end.

