unit Unit2; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, StdCtrls,
  EditBtn, ExtCtrls, Buttons,lclintf,LCLtype, ComCtrls, Grids,contnrs,upaint2ObjBase,uPaint2Obj,uliste;

type

  TDList = array of TDocumentList;
  { TForm4 }
  TForm4 = class(TForm)
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    CheckBox6: TCheckBox;
    CheckBox7: TCheckBox;
    Edit1: TEdit;
    FileNameEdit1: TFileNameEdit;
    FileNameEdit2: TFileNameEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    ListView1: TListView;
    ListView2: TListView;
    PageControl1: TPageControl;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    Panel5: TPanel;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure CheckBox1Change(Sender: TObject);
    procedure CheckBox3Exit(Sender: TObject);
    procedure CheckBox4Change(Sender: TObject);
    procedure CheckBox5Exit(Sender: TObject);
    procedure FileNameEdit1Exit(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormShow(Sender: TObject);
    procedure AddListView(fName:String; Grupdindex:integer; Gepackt,Versch:Boolean; Clear:Boolean = False);
    procedure ListView1AdvancedCustomDrawItem(Sender: TCustomListView;
      Item: TListItem; State: TCustomDrawState; Stage: TCustomDrawStage;
      var DefaultDraw: Boolean);
    procedure ListView1CustomDraw(Sender: TCustomListView; const ARect: TRect;
      var DefaultDraw: Boolean);
    procedure ListView1CustomDrawItem(Sender: TCustomListView; Item: TListItem;
      State: TCustomDrawState; var DefaultDraw: Boolean);
    procedure ListView1CustomDrawSubItem(Sender: TCustomListView;
      Item: TListItem; SubItem: Integer; State: TCustomDrawState;
      var DefaultDraw: Boolean);
    procedure ListView1MouseUp(Sender: TOBject; Button: TMouseButton;
      Shift: TShiftState; X,Y: Integer);
    procedure ListView1SelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure ListView2MouseDown(Sender: TOBject; Button: TMouseButton;
      Shift: TShiftState; X,Y: Integer);
    procedure ListView2SelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
      
  private
    { private declarations }
  public
    procedure AddDocumentlistView(a:array of TDocumentList);
    { public declarations }
  end; 

var
  Form4: TForm4; 
  cb:TCombobox;
  test:TObjectList;
implementation

{ TForm4 }

procedure TForm4.AddDocumentlistView(a:array of TDocumentList);
var
  i:integer;
begin

  listView2.Clear;
  for i:=0 to High(a) do begin
    with a[i],ListView2.items.Add do begin
      Caption:=FileName;
      SubItems.add(BoolToStr(userdefniert));
      SubItems.add(BoolToStr(Gepackt));
      SubItems.add(BoolToStr(Versch));
      Data:=a[i].objlist;
    end;
  end;

end;

procedure TForm4.AddListView(fName:String; Grupdindex:integer; Gepackt,Versch:Boolean;Clear:Boolean = False);
begin
  if Clear = True then listView1.Items.Clear;
  
  with ListView1.items.Add do begin
    caption:=fName;
    SubItems.add(IntTostr(Grupdindex));

    SubItems.add(BoolToStr(Gepackt));
    SubItems.add(BoolToStr(Versch));
  end;
end;

procedure TForm4.ListView1AdvancedCustomDrawItem(Sender: TCustomListView;
  Item: TListItem; State: TCustomDrawState; Stage: TCustomDrawStage;
  var DefaultDraw: Boolean);
begin

end;

procedure TForm4.ListView1CustomDraw(Sender: TCustomListView;
  const ARect: TRect; var DefaultDraw: Boolean);
begin

end;

procedure TForm4.ListView1CustomDrawItem(Sender: TCustomListView;
  Item: TListItem; State: TCustomDrawState; var DefaultDraw: Boolean);
begin

end;

procedure TForm4.ListView1CustomDrawSubItem(Sender: TCustomListView;
  Item: TListItem; SubItem: Integer; State: TCustomDrawState;
  var DefaultDraw: Boolean);
begin

end;

procedure TForm4.ListView1MouseUp(Sender: TOBject; Button: TMouseButton;
  Shift: TShiftState; X,Y: Integer);
begin

end;

procedure TForm4.ListView1SelectItem(Sender: TObject; Item: TListItem;
  Selected: Boolean);
begin
  if (ListView1.Selected <> NIL)  then begin
    with item do begin
      if Item.SubItems.count-1 >=1 then begin
        edit1.text:=SubItems[0];
        Checkbox5.Checked:=StrToBool(SubItems[1]);
        Checkbox6.Checked:=StrToBool(SubItems[2]);
      end;
    end;
  end;
end;

procedure TForm4.ListView2MouseDown(Sender: TOBject; Button: TMouseButton;
  Shift: TShiftState; X,Y: Integer);
begin
end;

procedure TForm4.ListView2SelectItem(Sender: TObject; Item: TListItem;
  Selected: Boolean);
var
  i:Integer;
begin
  if (Selected = True) and (ListView2.Selected.SubItems.count > 0) then begin
   // die listview1 wird übernommen
    if (listView1.items.count > 0) and (ListView1.Visible = True) then begin
      for i:=0 to ListView1.items.count-1 do begin
        TPaint2BasesObj(TObjectList(Item.data).Items[i]).saveinfo.gepackt:=StrToBool(ListView1.items[i].SubItems[1]);
        TPaint2BasesObj(TObjectList(Item.data).Items[i]).saveinfo.gruppenindex:=StrToint(ListView1.items[i].SubItems[0]);
        TPaint2BasesObj(TObjectList(Item.data).Items[i]).saveinfo.versch:=StrToBool(ListView1.items[i].SubItems[2]);
      end;
    end;
    
    FileNameEdit1.Text:=item.caption;
    Checkbox4.Checked:=StrToBool(item.SubItems[0]);
    Checkbox2.Checked:=StrToBool(item.SubItems[1]);
    Checkbox3.Checked:=StrToBool(item.SubItems[2]);
    
    if item.data <> NIL then begin
      for i:=0 to TObjectList(item.Data).Count-1 do begin
        with TPaint2BasesObj(TObjectList(item.Data).Items[i]) do begin
          AddListView(Name,saveinfo.gruppenindex,saveinfo.gepackt,saveinfo.versch,i = 0);
        end;
      
      end
    end;
  end;
end;

procedure TForm4.CheckBox1Change(Sender: TObject);
begin
  //Panel1.Visible:=not CheckBox1.checked;
  {if CheckBox1.checked = True then begin
    panel2.top:=72;
    form4.Height:=123;
  end
  else begin
    panel2.Top:=296;
    form4.Height:=349;
  end;}
end;

procedure TForm4.CheckBox3Exit(Sender: TObject);
begin

end;

procedure TForm4.CheckBox4Change(Sender: TObject);
begin
  TabSheet1.TabVisible:=Checkbox4.Checked;
  if TabSheet1.TabVisible then
    PageControl1.ActivePageIndex:=1;
  Checkbox2.Enabled:=not Checkbox4.Checked;
  Checkbox3.Enabled:=not Checkbox4.Checked;
end;

procedure TForm4.CheckBox5Exit(Sender: TObject);
begin
  if ListView1.Selected <> NIL then begin
    with ListView1.Selected do begin
      SubItems[0]:=Edit1.text;
      SubItems[1]:=BooltoStr(Checkbox5.Checked);
      SubItems[2]:=BooltoStr(Checkbox6.Checked);
    end;
  end;
end;

procedure TForm4.FileNameEdit1Exit(Sender: TObject);
begin
  if ListView2.Selected <> NIL then begin
    ListView2.Selected.caption:=FileNameEdit1.Text;
    ListView2.Selected.SubItems[0]:=BoolToStr(Checkbox4.Checked);
    ListView2.Selected.SubItems[1]:=BoolToStr(Checkbox2.Checked);
    ListView2.Selected.SubItems[2]:=BoolToStr(Checkbox3.Checked);
  end;
end;

procedure TForm4.BitBtn2Click(Sender: TObject); // abbrechen
begin
  tag:=0;
  close;
end;

procedure TForm4.BitBtn1Click(Sender: TObject); // OK
begin
  tag:=1;
  close;
end;

procedure TForm4.FormCreate(Sender: TObject);
begin
//  Checkbox1.Checked:=true;
  TabSheet1.TabVisible:=False;
  cb:=TCombobox.Create(ListView1);
end;

procedure TForm4.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState
  );
begin
  if key = VK_RETURN then bitbtn1Click(Sender);
  if key = VK_ESCAPE then bitbtn2Click(Sender);
end;

procedure TForm4.FormShow(Sender: TObject);
begin
  tag:=0;
end;

initialization
  {$I Unit2.lrs}

end.

