unit uFont;

{$MODE Delphi}

interface

uses
  LCLIntf, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Spin, CheckLst, ExtCtrls, ComCtrls, Buttons, LResources,
  ColorBox,vkeys;

type
  TFFont = class(TForm)
    Label1: TLabel;
    ListBox1: TListBox;
    Label2: TLabel;
    SpinEdit1: TSpinEdit;
    Label3: TLabel;
    CheckListBox1: TCheckListBox;
    Label4: TLabel;
    ColorBox1: TColorBox;
//    RichEdit1: TRichEdit;
    Bevel1: TBevel;
    Bevel2: TBevel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormCreate(Sender: TObject);
    procedure ListBox1DrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure ListBox1Click(Sender: TObject);
    procedure SpinEdit1Change(Sender: TObject);
    procedure CheckListBox1ClickCheck(Sender: TObject);
    procedure ColorBox1Change(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  FFont: TFFont;

implementation


procedure TFFont.BitBtn2Click(Sender: TObject);
begin
  tag:=1;
  close;
end;

procedure TFFont.BitBtn1Click(Sender: TObject);
begin
  tag:=2;
  close;
end;

procedure TFFont.FormShow(Sender: TObject);
begin
  tag:=0;
end;

procedure TFFont.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if key = vk_return then BitBtn1Click(Sender);
  if key = vk_escape then BitBtn2Click(Sender);
end;

procedure TFFont.FormCreate(Sender: TObject);
begin
  ListBox1.Items.text:=Screen.Fonts.text;
end;

procedure TFFont.ListBox1DrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; State: TOwnerDrawState);
begin
  with Listbox1.Canvas do begin
    FillRect(rect);
    font.Name:=Listbox1.items[index];
    TextOut(rect.left,rect.top,font.Name);
  end;
end;

procedure TFFont.ListBox1Click(Sender: TObject);
begin
//  RichEdit1.Font.name:=Listbox1.items[listbox1.itemindex];
end;

procedure TFFont.SpinEdit1Change(Sender: TObject);
begin
//  RichEdit1.Font.size:=Spinedit1.value;
end;

procedure TFFont.CheckListBox1ClickCheck(Sender: TObject);
//var
//  h:TFontStyles;
begin
{  with Checklistbox1 do begin
    if itemindex > -1 then begin
      if Checked[itemindex] = True then begin
        if itemindex = 0 then Include(h,fsbold);
        if itemindex = 1 then Include(h,fsItalic);
        if itemindex = 2 then Include(h,fsUnderline);
        if itemindex = 3 then Include(h,fsStrikeOut);
        RichEdit1.Font.Style:=h;
      end
      else begin
        if itemindex = 0 then Exclude(h,fsbold);
        if itemindex = 1 then Exclude(h,fsItalic);
        if itemindex = 2 then Exclude(h,fsUnderline);
        if itemindex = 3 then Exclude(h,fsStrikeOut);
        RichEdit1.Font.Style:=h;
      end;
    end;
  end;  }
end;

procedure TFFont.ColorBox1Change(Sender: TObject);
begin
//  richedit1.Font.color:=ColorBox1.Selected;
end;

initialization
  {$i uFont.lrs}
  {$i uFont.lrs}
  {$i uFont.lrs}

end.
