unit uToolbar;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  ComCtrls, StdCtrls, Buttons;

type

  { TToolbarmanger }

  TToolbarmanger = class(TForm)
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    Panel5: TPanel;
    Panel6: TPanel;
    SpeedButton1: TSpeedButton;
    TreeView1: TTreeView;
    TreeView2: TTreeView;
    procedure TreeView1DragDrop(Sender,Source: TObject; X,Y: Integer);
    procedure TreeView1DragOver(Sender,Source: TObject; X,Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure TreeView1GetSelectedIndex(Sender: TObject; Node: TTreeNode);
    procedure TreeView1MouseDown(Sender: TOBject; Button: TMouseButton;
      Shift: TShiftState; X,Y: Integer);
    procedure TreeView1StartDrag(Sender: TObject; var DragObject: TDragObject);
    procedure TreeView2DragDrop(Sender,Source: TObject; X,Y: Integer);
    procedure TreeView2DragOver(Sender,Source: TObject; X,Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure TreeView2StartDrag(Sender: TObject; var DragObject: TDragObject);
  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  Toolbarmanger: TToolbarmanger;

implementation

{ TToolbarmanger }

procedure TToolbarmanger.TreeView1GetSelectedIndex(Sender: TObject;
  Node: TTreeNode);
begin

end;

procedure TToolbarmanger.TreeView1DragDrop(Sender,Source: TObject; X,Y: Integer
  );
begin

end;

procedure TToolbarmanger.TreeView1DragOver(Sender,Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
begin
  Accept:=True;
end;

procedure TToolbarmanger.TreeView1MouseDown(Sender: TOBject;
  Button: TMouseButton; Shift: TShiftState; X,Y: Integer);
var
  w:Integer;
begin
  TreeView1.Selected:=TreeView1.GetNodeAt(x,y);
  if (TreeView1.Selected <> NIL) and (TreeView1.Selected.data <> NIL)then
//  ShowMessage(IntTostr(Integer(TreeView1.Selected.Data^)));
end;

procedure TToolbarmanger.TreeView1StartDrag(Sender: TObject;
  var DragObject: TDragObject);
var
  t:TDragObject;
begin
  t:=TDragObject.Create;
  t.ShowDragImage;
  DragObject:=t;
end;

procedure TToolbarmanger.TreeView2DragDrop(Sender,Source: TObject; X,Y: Integer
  );
begin
  ShowMEssage('OK');
end;

procedure TToolbarmanger.TreeView2DragOver(Sender,Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
begin
  Accept:=True;
end;

procedure TToolbarmanger.TreeView2StartDrag(Sender: TObject;
  var DragObject: TDragObject);
begin
end;

initialization
  {$I uToolbar.lrs}

end.

